<template>
    <div>
        <v-list-group class="group-title bordered">
            <template v-slot:activator>
                <v-list-item-title>Lenguajes</v-list-item-title>
            </template>
            <template v-slot:prependIcon>
                <HexButton class="action" :alwaysOn="true" @click="initLanguageDialog">
                    <v-icon>mdi-plus</v-icon>
                </HexButton>
            </template>

            <v-list-item v-for="lang in langMenus" class="group-content bordered" :key="lang.id">
                <v-list-item-content class="ml-10" v-text="lang.name"></v-list-item-content>

                <span class="mr-5">{{ lang.lastUpdated.toDate().toLocaleString() }}</span>
                <span>EDITAR</span>
                <HexButton class="small-button" @click="initLanguageDialog($event, lang)">
                    <v-icon>mdi-pencil</v-icon>
                </HexButton>
                <span class="ml-10">ELIMINAR</span>
                <HexButton class="small-button" @click="deleteLanguage(lang)">
                    <v-icon>mdi-delete</v-icon>
                </HexButton>
            </v-list-item>

            <v-list-item v-if="langMenus.length == 0" class="group-content bordered">
                <v-spacer></v-spacer>
                <v-list-item-content style="font-size:10px;"></v-list-item-content>
            </v-list-item>
        </v-list-group>
        <language
            :language="language"
            :show-dialog="showDialog"
            :menu-id="menuId"
            @setShowLangModal="setShowLangModal"
            @saveLanguage="saveLanguage"
            @currencyChange="currencyWarning"
        ></language>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { LangMenu } from '@/model/menu/LangMenu';
import Language from '@/components/menu/Language.vue';
import { LangMenuService } from '@/services/LangMenuService';
import HexButton from '@/components/commons/HexButton.vue';
import { newTimestamp } from '@/config/serializables';

@Component({ components: { Language, HexButton } })
export default class Languages extends Vue {
    @Prop({ default: () => [] })
    langMenus!: LangMenu[];
    @Prop({ default: '' })
    menuId!: string;

    language = new LangMenu('', '', '', '', '', -1, newTimestamp(), 0);
    showDialog = false;
    langMenuService = new LangMenuService();

    initLanguageDialog(event: Event, lang?: LangMenu) {
        if (!lang) {
            lang = new LangMenu('', '', '', '', '', -1, newTimestamp(), 0);
        }
        this.language = lang;
        this.showDialog = true;
    }

    setShowLangModal(show: boolean) {
        this.showDialog = show;
    }

    currencyWarning() {
        this.$emit('setMessage', 'DEBES DE ACTUALIZAR EL TIPO DE MONEDA EN EL PRECIO DE LOS PRODUCTOS', 'info');
    }

    async deleteLanguage(language: LangMenu) {
        await this.langMenuService.deleteLanguage(this.menuId, language);
        this.$emit('setMessage', 'LENGUAJE ELIMINADO', 'info');
    }

    async saveLanguage(language: LangMenu, fileIconLanguage: File) {
        if (language.id) {
            await this.langMenuService.updateLanguage(this.menuId, language, fileIconLanguage);
            this.$emit('setMessage', 'LENGUAJE ACTUALIZADO', 'success');
            return;
        }
        await this.langMenuService.createLanguage(this.menuId, language, fileIconLanguage);
        this.$emit('setMessage', 'LENGUAJE CREADO', 'success');
        return;
    }

    get languagesMenu() {
        return this.langMenus;
    }
}
</script>

<style scoped></style>
